(in-package :lep)


;;;;
;;;; SCM
;;;;

(defpackage :scm)

(defpackage :lisp
  (:import-from :cl :macroexpand-1)
  (:export :macroexpand-1))



;;;;
;;;; CLOS
;;;;

(defpackage :clos
  (:export walk-form))

(defun clos:walk-form (form)
  (flet ((expand (subform context env)
	   (declare (ignore context))
	   (macroexpand subform env)))
    (sb-pcl::walk-form form nil #'expand)))



;;;;
;;;; MP
;;;;

(defpackage :mp
  (:export #:process-kill #:*current-process*))

(defvar mp:*current-process* :current-process)

(defun mp:process-kill (process)
  ;; ELI calls (MP:PROCESS-KILL MP:*CURRENT-PROCESS*) to escape from listeners.
  (assert (eq process :current-process))
  (throw 'exit-listener nil))



;;;;
;;;; EXCL
;;;;

(defpackage :excl)

(defun excl::run-status-process ()
  ;; sb-thread doesn't have the GC hooks needed :(
  ;; show a silly animation instead until someone restores them ;-)
  (flet ((doit (str)
	   (princ str)
	   (force-output)
	   (sleep 0.25)))
    (loop
      (doit " - ")
      (doit " \\ ")
      (doit " | ")
      (doit " / "))))

(defun excl::start-emacs-lisp-interface
    (&optional use-background-streams
	       emacs-listener-number
	       port
	       (announce-to-file t))
  (declare (ignore use-background-streams emacs-listener-number)) ;XXX
  (lep:start-emacs-lisp-interface
   :default-port port
   :announce-to-stream announce-to-file))
